# -*- coding: UTF-8 -*-
from setuphelpers import *
import time


def install():
    bin_name = glob.glob("Firefox_Setup_*.exe")[0]

    # Translating locale
    for lang in ["fr", "en-US", "es-ES", "de", "it"]:
        if control.locale in lang:
            locale = lang
    app_uninstallkey = "Mozilla Firefox %s ESR (%s %s)" % (control.get_software_version(), control.architecture, locale)

    # Uninstalling others versions
    for uninstall in installed_softwares(name="Mozilla Firefox"):
        if not control.architecture in uninstall["name"] or not "ESR" in uninstall["name"]:
            print("Removing: %s" % (uninstall["name"]))
            killalltasks(control.get_impacted_process_list())
            run(uninstall_cmd(uninstall["key"]))
            time.sleep(15)  # Required for Firefox

    # Installing the software
    install_exe_if_needed(
        bin_name,
        silentflags="/S /PreventRebootRequired=false /TaskbarShortcut=false /DesktopShortcut=false /StartMenuShortcut=true /MaintenanceService=false /RegisterDefaultAgent=false /RemoveDistributionDir=false /OptionalExtensions=false",
        key=app_uninstallkey,
        min_version=control.get_software_version(),
    )

    # Making sure that Mozilla Maintenance Service is not installed
    for uninstall in installed_softwares(name="Mozilla Maintenance Service"):
        print("Removing: %s" % (uninstall["name"]))
        run(uninstall_cmd(uninstall["key"]))

    # Adding Minimal configuration for Firefox you may use the package "tis-config-firefox" for further options
    if not isfile(makepath(programfiles, "Mozilla Firefox", "distribution", "policies.json")):
        registry_set(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Mozilla\Firefox", "DisableAppUpdate", 1, REG_DWORD)
        registry_set(HKEY_LOCAL_MACHINE, r"SOFTWARE\Policies\Mozilla\Firefox", "DisableTelemetry", 1, REG_DWORD)
